import { Component, signal, computed, effect } from '@angular/core';  

@Component({
  selector: 'employee-info',
  templateUrl: './employee.component.html'  
})
export class EmployeeComponent  { 
  firstName = signal('Mohit');
  lastName = signal('Singh');
  employeeName = computed(() => `${this.firstName()} ${this.lastName()}`);

  constructor() {
    effect(() => console.log('Name changed:', this.employeeName()));
  }

  setEmployeeName(fName: string, lName: string) {
    this.firstName.set(fName);
    this.lastName.set(lName);
  }

  employee = [
    { name: 'Mohan', salary: 5000 },    
    { name: 'Ramesh', salary: 15000 },    
    { name: 'Vijay', salary: 12000 },  
  ];
  employeeList = signal(this.employee);
  totalSalary = computed(() => {
    return this.employeeList().reduce((name, salary) => name + salary.salary, 0);
  });

  removeItem(emp: any) {
    // Update the itemList signal by removing the selected item
    this.employeeList.set(this.employeeList().filter((i) => i !== emp));
  };
}